from main.Control import Control
from ITime import ITime

import time
import os


#
# Control for time-related stuff.
#
class Time(Control, ITime):

    def __init__(self):

        self.__timezone = ""

        Control.__init__(self)
        self._add_timer(1000, self.__tick)


    def __tick(self):

        self._update("time")
        self._update("date")
        return True


    def __set_timezone(self, tz): self.__timezone = tz
    def __get_timezone(self): return self.__timezone
    

    def __get_time_and_date(self):

        tzname = time.tzname[1] or time.tzname[0]
        os.environ["TZ"] = self.__timezone
        current_time = time.localtime(time.time())
        os.environ["TZ"] = tzname

        return current_time


    def __get_time(self):

        year, month, day, hours, minutes, seconds, weekday, julian, dsflag = \
               self.__get_time_and_date()
        return (hours, minutes, seconds)


    def __get_date(self):

        year, month, day, hours, minutes, seconds, weekday, julian, dsflag = \
               self.__get_time_and_date()
        return (year, month, day)
        


    timezone = property(__get_timezone, __set_timezone, doc = "the timezone")
    time = property(__get_time, None,
                    doc = "the current time (h, m, s)")
    date = property(__get_date, None,
                    doc = "the current date (y, m, d)")



#def new_control(): return Time()
def get_class(): return Time
