from main import HOME

import gtk
import select
import thread
import time


#
# Class for viewing log files.
#
class LogViewer(gtk.Dialog):

    def __init__(self, logfile):

        self.__running = False
        

        gtk.Dialog.__init__(self, _("Log Messages"), None, 0,
                            (gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
        self.set_has_separator(False)

        hbox = gtk.HBox()
        hbox.set_border_width(12)
        self.vbox.pack_start(hbox, True, True)

        self.__view = gtk.TextView()
        self.__view.set_size_request(500, 240)
        self.__view.set_editable(False)
        self.__view.set_wrap_mode(gtk.WRAP_CHAR)
        self.__log = self.__view.get_buffer()

        self.__scrwin = gtk.ScrolledWindow()
        self.__scrwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
        self.__scrwin.add(self.__view)

        hbox.pack_end(self.__scrwin, gtk.TRUE, gtk.TRUE)
        self.show_all()

        def stop(*args): self.__halt()
        def destroy(*args): self.destroy()

        ok_button = self.get_children()[0].get_children()[-1]. \
                    get_children()[-1]
        self.connect("destroy", stop)
        ok_button.connect("clicked", destroy)

        self.__run(logfile)


    def __run(self, logfile):

        fd = open(logfile, "r")
        thread.start_new_thread(self.__watch_file, (fd,))
        self.__running = True


    def __halt(self):

        self.__running = False
        

    def __append_log(self, text):

        self.__log.insert(self.__log.get_end_iter(), text)


    def __watch_file(self, fd):

        while (self.__running):
            import sys
            sys.stdout.flush()
            i, o, e = select.select([fd], [], [])
            for f in i:
                text = f.read()
                if (text):
                    gtk.idle_add(self.__append_log, text)
            time.sleep(0.5)
        #end while
        fd.close()
