from plugin.Interface import Interface
import gtk


#
# Dialog for inspecting controls.
#
class ControlInspector(gtk.Dialog):

    def __init__(self, control):

        gtk.Dialog.__init__(self, buttons = (gtk.STOCK_CLOSE,
                                             gtk.RESPONSE_CLOSE))
        self.set_default_size(400, 200)
        self.connect("response", self.__on_close)

        vbox = self.vbox

        name = control.__name__
        self.set_title("%s Control" % (name))
        #lbl = gtk.Label("<b>" + name + "</b>")
        #lbl.set_use_markup(True)
        #vbox.pack_start(lbl, False, False)

        scrwin = gtk.ScrolledWindow()
        scrwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
        vbox.pack_end(scrwin, True, True)

        box = gtk.VBox()
        scrwin.add_with_viewport(box)

        # list the interfaces and their descriptions
        interfaces = Interface.get_interfaces(control)
        cnt = 0
        for iface in interfaces:
            ident = iface.get_id()
            text = ""
            text += "<b>%s</b>\n\n" % (ident)

            for key in dir(iface):
                value = control.__dict__.get(key)
                if (not value): continue

                if (type(value) == property):
                    if (value.fget): r = "r"
                    else: r = ""
                    length = len(key)
                    text += "<tt>" + key + " " * (25 - length)
                    if (value.fget): text += "r "
                    else: text += "  "
                    if (value.fset): text += "w"
                    else: text += " "
                    text += "</tt>     " + (value.__doc__ or "") + \
                            "\n"
            #end for
            
            lbl = gtk.Label(text)
            lbl.set_use_markup(True)
            lbl.set_selectable(True)
            box.pack_start(lbl, False, False)

            # don't put a separator after the last entry
            if (cnt < len(interfaces) - 1):
                sep = gtk.HSeparator()
                box.pack_start(sep, False, False)

            cnt += 1
        #end for
        
        vbox.show_all()


    def __on_close(self, src, response):

        self.destroy()
