#! /usr/bin/env python
# A simple script to test controls interactively.

from plugin.Interface import Interface
from main import HOME
import sys
import os
import code
import __builtin__

sys.path.append(".")
sys.path.append(HOME)



def describe_interfaces(clss):
    """
    Returns a description of the interfaces of the given class.
    """

    out = ""
    interfaces = Interface.get_interfaces(clss)
    for i in interfaces:
        ident = i.get_id()
        
        out += "Interface: %s\n" % (ident)
        out += "-" * 80 + "\n"

        for key in dir(i):
            value = clss.__dict__.get(key)
            if (not value): continue
            
            if (type(value) == property):
                if (value.fget): r = "r"
                else: r = ""
                length = len(key)
                out += " " + key + " " * (25 - length)
                if (value.fget): out += "r "
                else: out += "  "
                if (value.fset): out += "w"
                else: out += " "
                out += "   " + (value.__doc__ or "no description") + "\n"
        #end for
        out += "\n"
    #end for
    
    return out



try:
    path = os.path.abspath(sys.argv[1])
    folder, base = os.path.split(path)
except:
    sys.exit("Usage: test-control.py <control-directory>")
    

cwd = os.getcwd()
os.chdir(folder)
try:
    module = __import__(base)
    os.chdir(base)
    clss = module.get_class()
    ctrl = clss()
    
except IOError:
    sys.exit("Could not load control %s." % (path))

print
print describe_interfaces(clss)
__builtin__.ctrl = ctrl
code.InteractiveConsole().interact("Use 'ctrl' to access the control. "
                                   "Press Ctrl+D to quit.")
